#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <powwow/defines.h>
#include <powwow/eval.h>
#include <powwow/list.h>
#include <powwow/main.h>

/* This is the set of perl functions that effect powwow */
MODULE = powwow		PACKAGE = powwow		

void
execute(input)
		char *input
	CODE:
		parse_user_input( input, 0 );

# This is how you access standard named vars
char *
get(varname)
		char *varname
	CODE:
		int idx;
		varnode *v = NULL;
		char retval[ 1024 ];
		/* DWIM, get the global var or named var based on if char1 is a digit */
		bzero( retval, 1024 );
		if( isdigit( varname[ 1 ] ) ) {
			sscanf( &varname[ 1 ], "%d", &idx );
			if( idx < NUMVAR ) {
				if( varname[ 0 ] == '@' ) {
					sprintf( retval, "%d", *VAR[ idx ].num );
				}else if( varname[ 0 ] == '$' ) {
                    if( *VAR[ idx ].str != NULL ) {
			            strncpy( retval, ptrdata( *VAR[ idx ].str ), 1024 );
                    }
				}
			}else{
				sprintf( retval, "Global variable index out of range" );
			}
		}else{
			if( varname[ 0 ] == '@' ) {
				v = *lookup_varnode( (char *)(varname + 1), 0 );
				if( v != NULL )
					sprintf( retval, "%d", v -> num );
			}else if( varname[ 0 ] == '$' ) {
				v = *lookup_varnode( (char *)(varname + 1), 1 );
				if( v != NULL && ptrdata( v -> str ) != NULL )
					strncpy( retval, ptrdata( v -> str ), 1024 );
			}
		}

		RETVAL = retval;
	OUTPUT:
		RETVAL

# this is to access the anonymous vars, e.g. $1/$2 in actions 
char *
avar(varname)
		char *varname
	CODE:
		int idx;
		char retval[ 1024 ];

		RETVAL = "";
		if( varname[ 0 ] == '@' ) {
			sscanf( varname, "@%d", &idx );
			sprintf( retval, "%d", *VAR[ idx ].num );
			RETVAL = retval;
		}else if( varname[ 0 ] == '$' ) {
			sscanf( varname, "$%d", &idx );
            if( *VAR[ idx ].str != NULL ) {
			    strncpy( retval, ptrdata( *VAR[ idx ].str ), 1024 );
            }
			RETVAL = retval;
		}

	OUTPUT:
		RETVAL
